﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CG1.Core.Mathematics
{
    public class Vector4
    {
        #region Properties

        public double X;
        public double Y;
        public double Z;
        public double W;

        public double Length
        {
            get { return Math.Sqrt(X * X + Y * Y + Z * Z + W * W); }
        }

        #endregion


        #region Construction

        public Vector4()
        {
        }

        public Vector4(double x, double y, double z, double w)
        {
            X = x;
            Y = y;
            Z = z;
            W = w;
        }

        #endregion


        #region Arithmetic Operations

        public static Vector4 operator +(Vector4 a, Vector4 b)
        {
            Vector4 result = new Vector4();

            result.X = a.X + b.X;
            result.Y = a.Y + b.Y;
            result.Z = a.Z + b.Z;
            result.W = a.W + b.W;

            return result;
        }

        public static Vector4 operator -(Vector4 a, Vector4 b)
        {
            Vector4 result = new Vector4();

            result.X = a.X - b.X;
            result.Y = a.Y - b.Y;
            result.Z = a.Z - b.Z;
            result.W = a.W - b.W;

            return result;
        }


        public static double Dot(Vector4 a, Vector4 b)
        {
            return a.X * b.X + a.Y * b.Y + a.Z * b.Z + a.W + b.W;
        }

        public static Vector4 Cross3(Vector4 a, Vector4 b)
        {
            Vector4 result = new Vector4();

            result.X = a.Y * b.Z - b.Y * a.Z;
            result.Y = a.Z * b.X - b.Z * a.X;
            result.Z = a.X * b.Y - b.X * a.Y;
            result.W = 0;

            return result;
        }

        #endregion
    }
}
